<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Nano Vs Vim? Which Terminal Text Editor Should You Choose?</title>
<meta name="author" content="dt" />
<meta name="description" content="DT Articles - Nano Vs Vim? Which Terminal Text Editor Should You Choose?
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Nano Vs Vim? Which Terminal Text Editor Should You Choose?</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org890ed2c">Nano Vs Vim? Which Terminal Text Editor Should You Choose?</a></li>
<li><a href="#org3380e9b">About this article</a></li>
<li><a href="#org935e347">An overview of these editors</a>
<ul>
<li><a href="#orgc3f0dcb">What is Nano?</a></li>
<li><a href="#org760760a">What is Vim?</a></li>
</ul>
</li>
<li><a href="#orgac4353e">Vim has modes, Nano does not.</a>
<ul>
<li><a href="#orgb9ed0a7">Explain Vim&rsquo;s modes</a></li>
<li><a href="#org445ddf6">Nano&rsquo;s keybindings are more complicated due to being non-modal</a></li>
<li><a href="#orgaaa70c3">Searching</a></li>
</ul>
</li>
<li><a href="#org7830200">Speed and Productivity</a>
<ul>
<li><a href="#org2fb5be3">Nano</a></li>
<li><a href="#org0d922b4">Vim</a></li>
</ul>
</li>
<li><a href="#org475b6fe">Learning Curve</a>
<ul>
<li><a href="#org6b27348">For basic use</a></li>
<li><a href="#orgd3a6c6c">For advanced use</a></li>
</ul>
</li>
<li><a href="#org80c9f88">Which should you use?</a>
<ul>
<li><a href="#orga7423a6">Nano</a></li>
<li><a href="#orga3a30cb">Vim</a>
<ul>
<li><a href="#org9490cf9">Footer</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="../kb/index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org890ed2c" class="outline-2">
<h2 id="org890ed2c">Nano Vs Vim? Which Terminal Text Editor Should You Choose?</h2>
<div class="outline-text-2" id="text-org890ed2c">
<p>
<i>By Derek Taylor at July 29, 2021</i>
</p>
</div>
</div>

<div id="outline-container-org3380e9b" class="outline-2">
<h2 id="org3380e9b">About this article</h2>
<div class="outline-text-2" id="text-org3380e9b">
<p>
The following are the show notes from my video <a href="https://odysee.com/@DistroTube:2/nano-or-vim-which-terminal-text-editor:3">Nano or Vim? Which Terminal Text Editor Should You Use?</a>  Since these are just show notes, it&rsquo;s not really written in a typical article-like narrative.
</p>
</div>
</div>

<div id="outline-container-org935e347" class="outline-2">
<h2 id="org935e347">An overview of these editors</h2>
<div class="outline-text-2" id="text-org935e347">
</div>
<div id="outline-container-orgc3f0dcb" class="outline-3">
<h3 id="orgc3f0dcb">What is Nano?</h3>
<div class="outline-text-3" id="text-orgc3f0dcb">
<p>
GNU Nano, usually just called &ldquo;nano,&rdquo; is an improvement on a earlier text editor named Pico, which was initially released in 1989.  GNU Nano was created in 1999 because the original Nano developer wanted a free software replacement for Pico, because Pico wasn&rsquo;t distributed under a free software license.  Nano is a simple WYSIWYG plain text editor.  It lacks most of the advanced features that more powerful editors include these days, such as window splitting, macros, auto-completion, viewing multiple files at once, vertical block editing, etc.
</p>
</div>
</div>
<div id="outline-container-org760760a" class="outline-3">
<h3 id="org760760a">What is Vim?</h3>
<div class="outline-text-3" id="text-org760760a">
<p>
Vim is an acronym for Vi Improved.  Vi is a text editor that dates back to the 1970s and is almost always pre-installed on Unix-like OSes such as Linux.  Vim is essentially a better Vi.  Vim was originally released in 1991.  One of the most well-known things about Vi/Vim is that they use hjkl as motion keys, because Vi was created in a time where many computer terminals didn&rsquo;t have arrow keys.  hjkl served double duty as both their characters and as arrow keys.  The other well-known aspect of Vim is that no one knows how to exit Vim.  This is a joke, of course.  :wq writes your document and quits.  :q! will quit without saving a document.  And :w of course would write to the file, it saves your work.
</p>
</div>
</div>
</div>
<div id="outline-container-orgac4353e" class="outline-2">
<h2 id="orgac4353e">Vim has modes, Nano does not.</h2>
<div class="outline-text-2" id="text-orgac4353e">
</div>
<div id="outline-container-orgb9ed0a7" class="outline-3">
<h3 id="orgb9ed0a7">Explain Vim&rsquo;s modes</h3>
<div class="outline-text-3" id="text-orgb9ed0a7">
<p>
The biggest difference between Vim and Nano is that Vim is modal, meaning it has modes.  For example, in Vim you have what is called &ldquo;normal mode&rdquo; for doing things like moving around the document, copy/paste, searching, etc&#x2026;anything that&rsquo;s not you actually typing text into the document.  For actually typing text to insert into the document, you need to be in &ldquo;insert mode&rdquo;.  You get into insert mode by typing &ldquo;i&rdquo;.  Then you can type normally.  When you are done typing what you needed to insert, hit ESC to get back into normal mode.
</p>
</div>
</div>
<div id="outline-container-org445ddf6" class="outline-3">
<h3 id="org445ddf6">Nano&rsquo;s keybindings are more complicated due to being non-modal</h3>
<div class="outline-text-3" id="text-org445ddf6">
<p>
Because you don&rsquo;t have modes, Nano&rsquo;s keybindings for things like moving forward/backward by word, or moving up/down by line, or searching&#x2026;those keybindings are actually more complicated than Vim&rsquo;s keybindings.
</p>
</div>
</div>
<div id="outline-container-orgaaa70c3" class="outline-3">
<h3 id="orgaaa70c3">Searching</h3>
<div class="outline-text-3" id="text-orgaaa70c3">
<ul class="org-ul">
<li>/ vs C-W</li>
<li>n/N vs M-W</li>
</ul>
</div>
</div>
</div>
<div id="outline-container-org7830200" class="outline-2">
<h2 id="org7830200">Speed and Productivity</h2>
<div class="outline-text-2" id="text-org7830200">
<p>
Even a brand new Vim user will probably notice that they get things done faster in Vim compared to Nano.
</p>
</div>
<div id="outline-container-org2fb5be3" class="outline-3">
<h3 id="org2fb5be3">Nano</h3>
<div class="outline-text-3" id="text-org2fb5be3">
<ul class="org-ul">
<li>C-d to delete char.</li>
<li>C-scace move forward by word.</li>
</ul>
</div>
</div>
<div id="outline-container-org0d922b4" class="outline-3">
<h3 id="org0d922b4">Vim</h3>
<div class="outline-text-3" id="text-org0d922b4">
<ul class="org-ul">
<li>Show visual mode and do some advanced edit.</li>
<li>Do a global substitution</li>
<li>Add line numbers to each line.
:%s/^/\=printf(&rsquo;%-4d&rsquo;, line(&rsquo;.&rsquo;))</li>
<li>Then reverse the order of the lines.
:g/^/m0</li>
</ul>
</div>
</div>
</div>
<div id="outline-container-org475b6fe" class="outline-2">
<h2 id="org475b6fe">Learning Curve</h2>
<div class="outline-text-2" id="text-org475b6fe">
</div>
<div id="outline-container-org6b27348" class="outline-3">
<h3 id="org6b27348">For basic use</h3>
<div class="outline-text-3" id="text-org6b27348">
<p>
Honestly, I think Nano and Vim are not that different as far as a learning curve.  If all you want to do is basic text editing, you can learn how to do basic text editing in either nano or vim rather quickly.  The only reason Vim is seen as having a learning curve is because it acts unlike any other editor that you&rsquo;ve probably used.  Nano acts like other plain text editors that you&rsquo;ve used&#x2026;like Notepad.  But both are easy to learn the basics.  Nano gives you a cheat sheet at the bottom of the page.  Vim comes with a vimtutor.  Just open a terminal and type vimtutor, and go through that document.  It takes maybe 20-30 minutes to learn the basics of Vim.
</p>
</div>
</div>
<div id="outline-container-orgd3a6c6c" class="outline-3">
<h3 id="orgd3a6c6c">For advanced use</h3>
<div class="outline-text-3" id="text-orgd3a6c6c">
<p>
Now, if you want to learn the intermediate to advanced features of Vim, like macros and global substitution and things like that, you may have to spend a little more time learning these with Vim, but just a little more time.  These are not complicated things to learn.  And if you need these kinds of advanced features, then you have to learn Vim because these features don&rsquo;t exist in Nano.
</p>
</div>
</div>
</div>
<div id="outline-container-org80c9f88" class="outline-2">
<h2 id="org80c9f88">Which should you use?</h2>
<div class="outline-text-2" id="text-org80c9f88">
</div>
<div id="outline-container-orga7423a6" class="outline-3">
<h3 id="orga7423a6">Nano</h3>
<div class="outline-text-3" id="text-orga7423a6">
<p>
Nano is a great text editor for beginners who are new to terminal-based text editing, or for those who only use their text editor occasionally to make simple edits.  If you consider yourself a casual Linux user, then Nano might be a good choice for you.  Some Linux users will tell you that using nano is &ldquo;uncool&rdquo; and everyone should use Vim or Emacs.  While the I agree that learning Vim is worth it, if you change a few lines of text once in a blue moon, then nano is all you need for that.
</p>
</div>
</div>
<div id="outline-container-orga3a30cb" class="outline-3">
<h3 id="orga3a30cb">Vim</h3>
<div class="outline-text-3" id="text-orga3a30cb">
<ul class="org-ul">
<li>Vim is a necessary tool to be familiar with if you are a Linux sysadmin.</li>
<li>Good for programmers who write a lot of text and need Vim&rsquo;s powerful toolset to manipulate that text.</li>
<li>Vim can also be a great editor for writers, who may want the power of Vim, but not the distraction of a word processor, while writing their works.</li>
</ul>
</div>

<div id="outline-container-org9490cf9" class="outline-4">
<h4 id="org9490cf9">Footer</h4>
<div class="outline-text-4" id="text-org9490cf9">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
